#
# spec file for package 7zip
#
%global debug_package %{nil}
%global version_nodots 2409

Name:           7zip
Version:        24.09
Release:        1%{?dist}
Summary:        7-Zip file archiver with a high compression ratio
License:        GNU LGPL
URL:            https://www.7-zip.org/
Packager:       Teddysun <i@teddysun.com>

Source0:        https://github.com/ip7z/7zip/releases/download/%{version}/7z%{version_nodots}-src.tar.xz
Source1:        https://www.7-zip.org/license.txt
Source2:        p7zip.sh
Source3:        7z.sh
Source4:        7za.sh
Source5:        7zr.sh
Source6:        7zz.sh
Source7:        7z.1
Source8:        7za.1
Source9:        7zr.1
Source10:       7zz.1
Source11:       p7zip.1
Provides:       p7zip-full, p7zip
Conflicts:      p7zip-full, p7zip
%if 0%{?el7}
BuildRequires: devtoolset-9-gcc devtoolset-9-gcc-c++ devtoolset-9-make
%endif
%if 0%{?el8}
BuildRequires: gcc-toolset-9-gcc gcc-toolset-9-gcc-c++ gcc-toolset-9-make
%endif
%if 0%{?rhel} > 8
BuildRequires: gcc gcc-c++ make
%endif

%description
7-Zip is a file archiver with a high compression ratio.
The main features of 7-Zip are:
 * High compression ratio in 7z format with LZMA and LZMA2 compression
 * Supported formats:
     * Packing / unpacking: 7z, XZ, BZIP2, GZIP, TAR, ZIP and WIM
     * Unpacking only: AR, ARJ, CAB, CHM, CPIO, CramFS, DMG, EXT, FAT,
         GPT, HFS, IHEX, ISO, LZH, LZMA, MBR, MSI, NSIS, NTFS, QCOW2,
         RPM, SquashFS, UDF, UEFI, VDI, VHD, VMDK, WIM, XAR and Z.
 * For ZIP and GZIP formats, 7-Zip provides a compression ratio that is
     2-10 % better than the ratio provided by PKZip and WinZip
 * Strong AES-256 encryption in 7z and ZIP formats
 * Powerful command line version
"7zip" provides:
 * /usr/bin/7z:  Full featured with plugin functionality.
 * /usr/bin/7za: Major formats/features only.
 * /usr/bin/7zr: LZMA (.7z, .lzma, .xz) only. Minimal executable.

%prep
%setup -q -c -n %{name}-%{version}

%build
%if 0%{?el7}
%enable_devtoolset9
%endif
%if 0%{?el8}
. /opt/rh/gcc-toolset-9/enable
%endif
make %{?_smp_mflags} -C CPP/7zip/Bundles/Alone2 -f ../../cmpl_gcc.mak
make %{?_smp_mflags} -C CPP/7zip/Bundles/Format7zF -f ../../cmpl_gcc.mak
make %{?_smp_mflags} -C CPP/7zip/UI/Console -f ../../cmpl_gcc.mak
make %{?_smp_mflags} -C CPP/7zip/Bundles/SFXCon -f ../../cmpl_gcc.mak
make %{?_smp_mflags} -C CPP/7zip/Bundles/Alone -f ../../cmpl_gcc.mak
make %{?_smp_mflags} -C CPP/7zip/Bundles/Alone7z -f ../../cmpl_gcc.mak

%install
%{__install} -d %{buildroot}%{_bindir}
%{__install} -d %{buildroot}%{_libexecdir}/%{name}
%{__install} -d %{buildroot}%{_mandir}/man1
%{__install} -d %{buildroot}%{_datadir}/licenses/%{name}
%{__install} -p -m 644 %{S:1} %{buildroot}%{_datadir}/licenses/%{name}
%{__install} -p -m 755 %{S:2} %{buildroot}%{_bindir}/p7zip
%{__install} -p -m 755 %{S:3} %{buildroot}%{_bindir}/7z
%{__install} -p -m 755 %{S:4} %{buildroot}%{_bindir}/7za
%{__install} -p -m 755 %{S:5} %{buildroot}%{_bindir}/7zr
%{__install} -p -m 755 %{S:6} %{buildroot}%{_bindir}/7zz
%{__install} -p -m 755 %{S:7} %{buildroot}%{_mandir}/man1
%{__install} -p -m 755 %{S:8} %{buildroot}%{_mandir}/man1
%{__install} -p -m 755 %{S:9} %{buildroot}%{_mandir}/man1
%{__install} -p -m 755 %{S:10} %{buildroot}%{_mandir}/man1
%{__install} -p -m 755 %{S:11} %{buildroot}%{_mandir}/man1
gzip -v %{buildroot}%{_mandir}/man1/*.1
%{__install} -p -m 755 CPP/7zip/Bundles/Alone/b/g/7za %{buildroot}%{_libexecdir}/%{name}
%{__install} -p -m 755 CPP/7zip/Bundles/Alone7z/b/g/7zr %{buildroot}%{_libexecdir}/%{name}
%{__install} -p -m 755 CPP/7zip/Bundles/Format7zF/b/g/7z.so %{buildroot}%{_libexecdir}/%{name}
%{__install} -p -m 755 CPP/7zip/UI/Console/b/g/7z %{buildroot}%{_libexecdir}/%{name}
%{__install} -p -m 755 CPP/7zip/Bundles/Alone2/b/g/7zz %{buildroot}%{_libexecdir}/%{name}
%{__install} -p -m 755 CPP/7zip/Bundles/SFXCon/b/g/7zCon %{buildroot}%{_libexecdir}/%{name}/7zCon.sfx

%files
%{_bindir}/*
%{_libexecdir}/%{name}/*
%{_mandir}/man1/*
%{_datadir}/licenses/%{name}/license.txt
%doc DOC/*

%changelog
* Thu Dec 19 2024 Teddysun <i@teddysun.com> - 24.09-1
- Update version to 24.09

* Mon Aug 12 2024 Teddysun <i@teddysun.com> - 24.08-1
- Update version to 24.08

* Wed Jun 19 2024 Teddysun <i@teddysun.com> - 24.07-1
- Update version to 24.07

* Mon May 27 2024 Teddysun <i@teddysun.com> - 24.06-1
- Update version to 24.06

* Thu May 16 2024 Teddysun <i@teddysun.com> - 24.05-1
- Update version to 24.05

* Sat Apr 20 2024 Teddysun <i@teddysun.com> - 23.01-1
- Initial version 23.01
